<?php
/*

This file gets included in a php file that is included on every php page on your web site
such as Settings.php

Who's Online PHP Script by Mike Challis
Free PHP Scripts - www.642weather.com/weather/scripts.php
Download         - www.642weather.com/weather/scripts/whos-online.zip
Live Example     - www.642weather.com/weather/whos-online.php
Contact Mike     - www.642weather.com/weather/contact_us.php

Version: 3.02 - 29-Apr-2014 see changelog.txt for changes

You are free to use and modify the code

This php code provided "as is", and Long Beach Weather (Michael Challis)
disclaims any and all warranties, whether express or implied, including
(without limitation) any implied warranties of merchantability or
fitness for a particular purpose.

Copyright (C) 2008-2014 Mike Challis  (www.642weather.com/weather/contact_us.php)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// settings are now located in include-whos-online-settings.php


// no settings below this line --------------------------------------------

$C['version'] = 'Version: 3.02 - 29-Apr-2014 - Who\'s Online PHP Script by Mike Challis';

// do not change this setting here
if (!isset($C['files_path'])) {
    $C['files_path'] = '';
}
if (!isset($C['files_url'])) {
    $C['files_url'] = '';
}

require_once ($C['files_path'].'include-whos-online-settings.php');

if ( $C['dbpass'] == '' || $C['dbuser'] =='' || $C['dbname'] == '' ) {
     echo '<p>Error: You need to set the settings for
     dbname, dbuser, and dbpass for the whos online script to function.</p>';
     exit;
}

$wo_dbh = ''; // initialize the mysql link identifier
$wo_record_array = array();

if (isset($_GET['wo-last-url']) && preg_match("/^[a-zA-Z0-9-_.\/]{1,40}$/i", $_GET['wo-last-url'])) {
 $whos_online_records = update_whos_online();
}

function update_whos_online() {
  // this function runs on every page hit and inserts or updates the whos online
  // information temporarily stored in the whos_online database table
    global $wo_dbh, $C; // settings

    if ($C['disable_whos_online']) {
        return 'whos online is disabled';
    }

	$ip_address    = get_ip_address();
    $C['visitor_ip'] = $ip_address;

    if (isset($_GET['wo-last-url']) && preg_match("/^[a-zA-Z0-9-_.\/]{1,40}$/i", $_GET['wo-last-url'])) {
            $last_page_url = $_GET['wo-last-url'];
    } else {
            $last_page_url = get_request_uri();
            if ( isset($C['last_page_corrections']) && is_array($C['last_page_corrections']) && !empty($C['last_page_corrections']) ) {
               foreach ($C['last_page_corrections'] as $k => $v) {
                    if (preg_match("/$k/i", $last_page_url)) {
                       $last_page_url = $v;
                    }
               }
            }
    }
    $http_referer  = get_http_referer();
    $user_agent    = get_http_user_agent();
    $user_agent_lower = strtolower($user_agent);
    $current_time  = time();
    $xx_mins_ago   = ($current_time - absint(($C['track_time'] * 60)));

    // see if the user is a spider (bot) or not
    // based on a list of spiders in spiders.txt file
    $spider_flag = 0;
    if (not_null($user_agent_lower) && $spiders = file($C['files_path'].'spiders.txt') ) {
       for ($i=0, $n=sizeof($spiders); $i<$n; $i++) {
         if (not_null($spiders[$i]) && is_integer(strpos($user_agent_lower, trim($spiders[$i]))) ) {
           $spider_flag = $spiders[$i];
           break;
         }
       }
    }

    if ( $spider_flag ){
      // is a bot, the bot name is extracted from the User Agent name later on in the whos-online viewer script
      $name = $user_agent_lower;
    } else {
      // is not a bot, must be a regular visitor
      $name = 'Guest';
    }

    // Connect to the mysql database now
	$wo_dbh = mysql_connect($C['dbhost'], $C['dbuser'], $C['dbpass']);
    if (!$wo_dbh) die('Could not connect: ' . mysql_error($wo_dbh));
    mysql_select_db($C['dbname'],$wo_dbh) or die(mysql_error($wo_dbh));

    if ($C['store_days'] > 0) {
            // remove visitor entries that have expired after $C['store_days'], save nickname friends
            $xx_days_ago_time = (time() - ($C['store_days'] * 60*60*24));
            $query = "DELETE from " . TABLE_WHOS_ONLINE . "
                      WHERE (time_last_click < '" . $xx_days_ago_time . "' and nickname = '')
                      OR   (time_last_click < '" . $xx_days_ago_time . "' and nickname IS NULL)";
    } else {
            // remove visitor entries that have expired after $C['track_time'], save nickname friends
            $query = "DELETE from " . TABLE_WHOS_ONLINE . "
                      WHERE (time_last_click < '" . $xx_mins_ago . "' and nickname = '')
                      OR   (time_last_click < '" . $xx_mins_ago . "' and nickname IS NULL)";
    }

    // see if the current site visitor has an entry
    $query = "SELECT ip_address, country_code, nickname, hostname, time_last_click, num_visits
              FROM " . TABLE_WHOS_ONLINE . "
              WHERE session_id = '" . wo_clean_input($ip_address) . "'";

    $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);
    $stored_user  = mysql_fetch_array($result);

    if ($C['enable_location_plugin']) {
       clearstatcache();
       // make sure the location plugin is installed
       if ( !file_exists($C['files_path'].'include-whos-online-geoip.php') ) {
             // not going to work
             $C['enable_location_plugin'] = 0;
       }
       if ( !isset($C['geolite_path']) ) { // allow optional custom setting of geolite path
          $C['geolite_path'] = $C['files_path'];
       }
       if ( !file_exists($C['geolite_path'].'GeoLiteCity.dat') ) {
             // give up, this way the whole site does not error
             $C['enable_location_plugin'] = 0;
       }
    }

    if ($name != '' && $ip_address != '') { // skip if empty
      if (isset($stored_user) && $stored_user['ip_address'] != '') {

        // have an entry, update it
        $query = "UPDATE " . TABLE_WHOS_ONLINE . "
        SET
        name             = '" . db_sanitize_input($name) . "',
        ip_address       = '" . db_sanitize_input($ip_address) . "',";

        // sometimes the country is blank, look it up again
        // this can happen if you just enabled the location plugin
        if ($C['enable_location_plugin'] && $stored_user['country_code'] == '') {
            $location_info = get_location_info($ip_address);

            $query .= "country_name = '" . db_sanitize_input($location_info['country_name']) . "',
                       country_code = '" . db_sanitize_input($location_info['country_code']) . "',
                       city_name    = '" . db_sanitize_input($location_info['city_name']) . "',
                       state_name   = '" . db_sanitize_input($location_info['state_name']) . "',
                       state_code   = '" . db_sanitize_input($location_info['state_code']) . "',
                       latitude     = '" . db_sanitize_input($location_info['latitude']) . "',
                       longitude    = '" . db_sanitize_input($location_info['longitude']) . "',";
        }
        // is a nickname user coming back online? then need to re-set the time entry and online time
        if ( $stored_user['time_last_click'] < $xx_mins_ago ) {
            $hostname = ($C['enable_host_lookups']) ? gethostbyaddr_timeout($ip_address,2) : '';
            $query .= "num_visits       = '" . db_sanitize_input($stored_user['num_visits'] + 1) . "',
                       time_entry       = '" . db_sanitize_input($current_time) . "',
                       time_last_click  = '" . db_sanitize_input($current_time) . "',
                       last_page_url    = '" . db_sanitize_input($last_page_url) . "',
                       http_referer     = '" . db_sanitize_input($http_referer) . "',
                       hostname         = '" . db_sanitize_input($hostname) . "',
                       user_agent       = '" . db_sanitize_input($user_agent) . "'
                       WHERE session_id = '" . db_sanitize_input($ip_address) . "'";
        } else {
            if ($C['enable_host_lookups']) {
                    $hostname = (empty($stored_user['hostname'])) ? gethostbyaddr_timeout($ip_address,2) : $stored_user['hostname'];
            } else {
                    $hostname = '';
            }
            $query .= "time_last_click  = '" . db_sanitize_input($current_time) . "',
                       hostname         = '" . db_sanitize_input($hostname) . "',
                       last_page_url    = '" . db_sanitize_input($last_page_url) . "'
                       WHERE session_id = '" . db_sanitize_input($ip_address) . "'";
        }


      } else {
        // do not have an entry, insert it

        if ($C['enable_location_plugin']) {
               $location_info = get_location_info($ip_address);
               $country_name = $location_info['country_name'];
               $country_code = $location_info['country_code'];
               $city_name    = $location_info['city_name'];
               $state_name   = $location_info['state_name'];
               $state_code   = $location_info['state_code'];
               $latitude     = $location_info['latitude'];
               $longitude    = $location_info['longitude'];
        } else {
               $country_name = '';
               $country_code = '';
               $city_name    = '';
               $state_name   = '';
               $state_code   = '';
               $latitude     = '0.0000';
               $longitude    = '0.0000';
        }

        $hostname = ($C['enable_host_lookups']) ? gethostbyaddr_timeout($ip_address,2) : '';

        $query = "INSERT IGNORE INTO " . TABLE_WHOS_ONLINE . "
        (session_id,
        ip_address,
        name,
        country_name,
        country_code,
        city_name,
        state_name,
        state_code,
        latitude,
        longitude,
        last_page_url,
        http_referer,
        user_agent,
        hostname,
        time_entry,
        time_last_click,
        num_visits)
        values (
                '" . db_sanitize_input($ip_address) . "',
                '" . db_sanitize_input($ip_address) . "',
                '" . db_sanitize_input($name) . "',
                '" . db_sanitize_input($country_name) . "',
                '" . db_sanitize_input($country_code) . "',
                '" . db_sanitize_input($city_name) . "',
                '" . db_sanitize_input($state_name) . "',
                '" . db_sanitize_input($state_code) . "',
                '" . db_sanitize_input($latitude) . "',
                '" . db_sanitize_input($longitude) . "',
                '" . db_sanitize_input($last_page_url) . "',
                '" . db_sanitize_input($http_referer) . "',
                '" . db_sanitize_input($user_agent) . "',
                '" . db_sanitize_input($hostname) . "',
                '" . db_sanitize_input($current_time) . "',
                '" . db_sanitize_input($current_time) . "',
                '1')";
      } // end  else  do not have an entry, insert it
      $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);
    }// end skip if empty

    // set the day, month, year, all time records and return the 'visitors online right now' count
    $visitors_now = set_whos_records();

    // get the day, month, year, all time records for display on web site,
    // recycle the 'visitors online right now' count ( I am feeling thrifty )
    $whos_online_records = get_whos_records($visitors_now);

    // close the database connection
	mysql_close($wo_dbh);

    // return the day, month, year, all time records for display on web site
    return $whos_online_records;

} // end function update_whos_online


function get_location_info($user_ip) {
   global $C;
  // this function looks up location info from the maxmind geoip database
  // and returns $country_info array

  // lookup country info for this ip
  // geoip lookup
  if (!function_exists('geoip_open')) {
    require_once($C['files_path'].'include-whos-online-geoip.php');
  }

  if ( !isset($C['geolite_path']) ) { // allow optional custom setting of geolite path
     $C['geolite_path'] = $C['files_path'];
  }
  $gi = geoip_open($C['geolite_path'].'GeoLiteCity.dat', GEOIP_STANDARD);

  $record = geoip_record_by_addr($gi, "$user_ip");
  geoip_close($gi);

  $location_info = array();    // Create Result Array

  $location_info['provider']     = '';
  $location_info['city_name']    = (isset($record->city)) ? $record->city : '';
  $location_info['state_name']   = (isset($record->country_code) && isset($record->region)) ? $GEOIP_REGION_NAME[$record->country_code][$record->region] : '';
  $location_info['state_code']   = (isset($record->region)) ? strtoupper($record->region) : '';
  $location_info['country_name'] = (isset($record->country_name)) ? $record->country_name : '--';
  $location_info['country_code'] = (isset($record->country_code)) ? strtoupper($record->country_code) : '--';
  $location_info['latitude']     = (isset($record->latitude)) ? $record->latitude : '0';
  $location_info['longitude']    = (isset($record->longitude)) ? $record->longitude : '0';

  // this fixes accent characters on UTF-8, only when this option is enabled.
  if ($C['enable_utf8'] && function_exists('utf8_encode') ) {
    if ($location_info['city_name'] != '' ) {
       $location_info['city_name'] = utf8_encode($location_info['city_name']);
    }
    if ($location_info['state_name'] != '') {
       $location_info['state_name'] = utf8_encode($location_info['state_name']);
    }
    if ($location_info['country_name'] != '') {
       $location_info['country_name'] = utf8_encode($location_info['country_name']);
    }
  }

  return $location_info;
}

function set_whos_records() {
  // this function updates the day, month, year, all time records
  // and returns 'visitors online right now' count
  global $wo_dbh, $C; // settings

  // now() adjusted to php timezone, othersize mysql date time could be off
  // my server is in Eastern time zone, but I am in Pacific time zone,
  // I have already set my php timezone in my template settings file putenv('TZ=America/Los_Angeles');
  $mysql_now = date( 'Y-m-d H:i:s' );

  // select the 'visitors online right now' count, except for our nickname friends not online now
  $query = "SELECT count(*) as count FROM " . TABLE_WHOS_ONLINE ."
  WHERE time_last_click > '" . (time() - absint(($C['track_time'] * 60))) . "'";

  $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);
  $visitors = mysql_fetch_array($result);

  // set today record if day changes or count is higher than stored count
  $query = "UPDATE " . TABLE_STATS . "
  SET
  count = '" . wo_clean_input($visitors['count']) . "',
  time = '".$mysql_now."'
  WHERE (day('".$mysql_now."') != day(time) and type = 'day')
     OR (count < '" . wo_clean_input($visitors['count']) . "' and type = 'day')";
  $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);

  // set month record if month changes or count is higher than stored count
  $query = "UPDATE " . TABLE_STATS . "
  SET
  count = '" . wo_clean_input($visitors['count']) . "',
  time = '".$mysql_now."'
  WHERE (month('".$mysql_now."') != month(time) and type = 'month')
     OR (count < '" . wo_clean_input($visitors['count']) . "' and type = 'month')";
  $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);

  // set year record if year changes or count is higher than stored count
  $query = "UPDATE " . TABLE_STATS . "
  SET
  count = '" . wo_clean_input($visitors['count']) . "',
  time = '".$mysql_now."'
  WHERE (year('".$mysql_now."') != year(time) and type = 'year')
     OR (count < '" . wo_clean_input($visitors['count']) . "' and type = 'year')";
  $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);

  // set all time record if count is higher than stored count
  $query = "UPDATE " . TABLE_STATS . "
  SET
  count = '" . wo_clean_input($visitors['count']) . "',
  time = '".$mysql_now."'
  WHERE count < '" . wo_clean_input($visitors['count']) . "'
  and type = 'all'";
  $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);

  // return the 'visitors online right now' count ( I recycle )
  return $visitors['count'];

} // end function set_whos_records

function get_whos_records($visitors_now) {
  // get the day, month, year, all time records for display on web site,
  // use the recycled the 'visitors online right now' count
  global $wo_record_array, $wo_dbh, $C; // settings

  // fetch the day, month, year, all time records
  $query = "SELECT type, count, time FROM " . TABLE_STATS;
  $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);

  // are any stats there?
  if (!$num_rows = mysql_num_rows($result) ) {
     // jump start the stats now
     $result = mysql_query("INSERT INTO ".TABLE_STATS." (`type` ,`count` ,`time`) VALUES ('day', '1', now());")   or die("Invalid query: " . mysql_error().__LINE__.__FILE__);
     $result = mysql_query("INSERT INTO ".TABLE_STATS." (`type` ,`count` ,`time`) VALUES ('month', '1', now());") or die("Invalid query: " . mysql_error().__LINE__.__FILE__);
     $result = mysql_query("INSERT INTO ".TABLE_STATS." (`type` ,`count` ,`time`) VALUES ('year', '1', now());")  or die("Invalid query: " . mysql_error().__LINE__.__FILE__);
     $result = mysql_query("INSERT INTO ".TABLE_STATS." (`type` ,`count` ,`time`) VALUES ('all', '1', now());")   or die("Invalid query: " . mysql_error().__LINE__.__FILE__);
     // fetch the day, month, year, all time records
     $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);
  }

  $wo_record_array['now'] = sprintf(TEXT_VISITORS_ONLINE_NOW,$visitors_now);
  $string = sprintf(TEXT_VISITORS_ONLINE_NOW,$visitors_now).'<br />';

  while ( $visitors  = mysql_fetch_array($result) ) {

     if($visitors['type'] == 'day') {
        $wo_record_array['today'] = TEXT_MAX_VISITORS_TODAY.': ' . $visitors['count'] .' '.TEXT_AT.' '. date($C['time_format'],strtotime($visitors['time']));
        $string .= TEXT_MAX_VISITORS_TODAY.': ' . $visitors['count'] .' '.TEXT_AT.' '. date($C['time_format'],strtotime($visitors['time'])).'<br />';
     }
     if($visitors['type'] == 'month'){
       $wo_record_array['month'] = TEXT_THIS_MONTH.': ' . $visitors['count'] .' '.TEXT_AT.' '. date($C['date_time_format'],strtotime($visitors['time']));
       $string .= TEXT_THIS_MONTH.': ' . $visitors['count'] .' '.TEXT_AT.' '. date($C['date_time_format'],strtotime($visitors['time'])).'<br />';
     }
     if($visitors['type'] == 'year') {
       $wo_record_array['year'] = TEXT_THIS_YEAR.': ' . $visitors['count'] .' '.TEXT_AT.' '.  date($C['date_time_format'],strtotime($visitors['time']));
       $string .= TEXT_THIS_YEAR.': ' . $visitors['count'] .' '.TEXT_AT.' '.  date($C['date_time_format'],strtotime($visitors['time'])).'<br />';
     }
     if($visitors['type'] == 'all') {
        $wo_record_array['all'] = TEXT_ALL_TIME.': ' . $visitors['count'] .' '.TEXT_AT.' '.  date($C['date_time_format'],strtotime($visitors['time']));
        $string .= TEXT_ALL_TIME.': ' . $visitors['count'] .' '.TEXT_AT.' '.  date($C['date_time_format'],strtotime($visitors['time'])).'<br />';
     }

  }
  return $string;

} // end function get_whos_records


 function process_login() {
  // password protection feature to check if logged in or not
  // also sets the cookie when logged in

   global $LOGIN_INFO, $C;

  // timeout in seconds
  $timeout = ($C['login_timeout_minutes'] == 0 ? 0 : time() + $C['login_timeout_minutes'] * 60);

  // if logout, clear login cooke
  if(isset($_GET['logout'])) {
    setcookie("wo_verify", '', $timeout, '/');
    return false;
  }

  // user provided password
  if (isset($_POST['access_password'])) {

    $user = isset($_POST['access_user']) ? $_POST['access_user'] : '';
    $pass = $_POST['access_password'];
    if (!$C['require_username_password'] && !in_array($pass, $LOGIN_INFO)
     || ($C['require_username_password'] && ( !array_key_exists($user, $LOGIN_INFO) || $LOGIN_INFO[$user] != $pass ) )
      ) {
      $C['login_error'] = TEXT_INVALID_LOGIN;
      return false;
    }
    else {
      // set cookie if password was validated
      setcookie("wo_verify", md5($user.'%'.$pass), $timeout, '/');

      // clear login post vars
      unset($_POST['access_user']);
      unset($_POST['access_password']);
      unset($_POST['Submit']);
      return true;
    }

  } else {

    // check if password cookie is set
    if (!isset($_COOKIE['wo_verify'])) {
      return false;
    }

    // check if cookie actually passes user login test
    $found = false;
    foreach($LOGIN_INFO as $key => $val) {
       $lp = ($C['require_username_password'] ? $key : '') .'%'.$val;
       if ($_COOKIE['wo_verify'] == md5($lp)) {
         $found = true;
        // prolong timeout
        if ($C['login_timeout_check_activity']) {
          setcookie("wo_verify", md5($lp), $timeout, '/');
        }
        break;
      }
    }
    if ($found) {
            return true;
    } else {
            return false;
    }

  }
  return false;
} // end function process_login

// show login form
function show_login_form() {
  // password protection feature to show login form
  global $C;

 echo'
  <form method="post" action="'.$C['filename_whos_online'].'">
  ';

    if ( isset($C['login_error']) ) echo '<span style="color:red">'. $C['login_error'] .'</span><br />
    ';
    if ($C['require_username_password']) {
           echo '<label for="access_user">'.TEXT_USER.':</label> <input type="text" id="access_user" name="access_user" size="10" />
           ';
           echo '<label for="access_password">'.TEXT_PASSWORD.':</label> <input type="password" id="access_password" name="access_password" size="10" />
           ';
    } else {
           echo '<label for="access_password">'.TEXT_PASSWORD.':</label> <input type="password" id="access_password" name="access_password" size="10" />
           ';
    }

      echo  ' <input type="submit" name="Submit" value="'.TEXT_LOGIN.'" />
  </form>
  ';

} // end  show_login_form

// show logout link
function show_logout_link() {
  // password protection feature to show logout link
  global $C;

 echo '<a href="'.$C['filename_whos_online'].'?logout=1">'.TEXT_LOGOUT.'</a><br /><br />
  ';

} // end function show_logout_link

function get_whos_online_worldmap ($MS = 0) {
  // reads the whos-online database and makes html code to display a visitors last 15 minutes
  // thanks to pinto (www.joske-online.be) for the idea and code sample
  global $C;

  if (!$C['enable_location_plugin']) {
     return '<p>get_whos_online_worldmap error: whos online location_plugin not enabled or installed</p>';
  }

  // set lat lon coordinates for worldmaps and custom regional maps.
  $ul_lat=0; $ul_lon=0; $lr_lat=360; $lr_lon=180; // default worldmap

  if ( isset($MS['ul_lat']) && is_numeric($MS['ul_lat'])  ) {
     $ul_lat = $MS['ul_lat'];
  }
  if ( isset($MS['ul_lon']) && is_numeric($MS['ul_lon'])  ) {
     $ul_lon = $MS['ul_lon'];
  }
  if ( isset($MS['lr_lat']) && is_numeric($MS['lr_lat'])  ) {
     $lr_lat = $MS['lr_lat'];
  }
  if ( isset($MS['lr_lon']) && is_numeric($MS['lr_lon'])  ) {
     $lr_lon = $MS['lr_lon'];
  }
  $offset_x = $offset_y = 0;
  if ( isset($MS['offset_x']) && is_numeric($MS['offset_x'])  ) {
     $offset_x = floor($MS['offset_x']);
  }
  if ( isset($MS['offset_y']) && is_numeric($MS['offset_y'])  ) {
     $offset_y = floor($MS['offset_y']);
  }
  //echo "ul_lat=$ul_lat ul_lon=$ul_lon lr_lat=$lr_lat lr_lon=$lr_lon";

  // select text on or off
  $G['text_display'] = 'off'; // default
  if ( isset($MS['text']) && $MS['text'] == 'on' ) {
    $G['text_display']  = 'on';
  }
  // select text align
  $G['text_align']  = 'cb'; // default center bottom
  if( isset($MS['textalign']) && validate_text_align($MS['textalign']) ) {
    $G['text_align'] =  $MS['textalign'];
  }
  // select text color by hex code
  $G['text_color']  = '336699'; // default blue
  if( isset($MS['textcolor']) && validate_color_wo($MS['textcolor']) ) {
    $G['text_color'] =  str_replace('#','',$MS['textcolor']);  // hex
  }
  // select text shadow color by hex code
  $G['text_shadow_color']  = 'FFFFFF'; // default white
  if( isset($MS['textshadow']) && validate_color_wo($MS['textshadow']) ) {
    $G['text_shadow_color'] =  str_replace('#','',$MS['textshadow']);  // hex
  }
  // select pins on or off
  $G['pins_display'] = true;  // default
  if ( isset($MS['pins']) && $MS['pins'] == 'off' ) {
    $G['pins_display'] = false;
  }

  // select time units
  $G['time'] = absint($C['track_time']);
  $G['units'] = 'minutes';
  if ( isset($MS['time']) && is_numeric($MS['time']) && isset($MS['units']) ) {
      $time  = floor($MS['time']);
      $units = $MS['units'];
      $units_filtered = '';
     if ( $time > 0 && ($units == 'minute' || $units == 'minutes') ) {
           $seconds_ago = ($time * 60); // minutes
           $units_filtered = $units;
             $G['time'] = $time;
             $G['units'] = $units;
     } else if( $time > 0 && ($units == 'hour' || $units == 'hours') ) {
           $seconds_ago = ($time * 60*60); // hours
           $units_filtered = $units;
           $G['time'] = $time;
           $G['units'] = $units;
     } else if( $time > 0 && ($units == 'day' || $units == 'days') ) {
           $seconds_ago = ($time * 60*60*24); // days
           $units_filtered = $units;
           $G['time'] = $time;
           $G['units'] = $units;
     } else {
           $seconds_ago = absint($C['track_time'] * 60); // default
     }

  } else {
          $seconds_ago = absint($C['track_time'] * 60); // default
  }

  // select map image
  $image_worldmap = $C['files_url'] . 'images/' . $C['image_worldmap'];  // default
  $image_worldmap_path = $C['files_path'] . 'images/' . $C['image_worldmap'];  // default
  $G['map'] = 1;
  if ( isset($MS['map']) && is_numeric($MS['map']) ) {
     $G['map'] = floor($MS['map']);
     $image_worldmap = $C['files_url'] . 'images/' . $C['image_worldmap_'.$G['map']];
     $image_worldmap_path = $C['files_path'] . 'images/' . $C['image_worldmap_'.$G['map']];
     if (!file_exists($C['files_path'] . 'images/' . $C['image_worldmap_'.$G['map']])) {
          $image_worldmap = $C['files_url'] . 'images/' . $C['image_worldmap'];  // default
          $image_worldmap_path = $C['files_path'] . 'images/' . $C['image_worldmap'];  // default
          $G['map'] = 1;
     }
  }
  // select pin image
  $image_pin = $C['files_url'] . 'images/' . $C['image_pin'];  // default
  $image_pin_path = $C['files_path'] . 'images/' . $C['image_pin'];  // default
  $G['pin'] = 1;
  if ( isset($MS['pin']) && is_numeric($MS['pin']) ) {
     $G['pin'] = floor($MS['pin']);
     $image_pin = $C['files_url'] . 'images/' . $C['image_pin_'.$G['pin']];
     $image_pin_path = $C['files_path'] . 'images/' . $C['image_pin_'.$G['pin']];
     if (!file_exists($C['files_path'] . 'images/' . $C['image_pin_'.$G['pin']])) {
          $image_pin = $C['files_url'] . 'images/' . $C['image_pin'];  // default
          $image_pin_path = $C['files_path'] . 'images/' . $C['image_pin'];  // default
          $G['pin'] = 1;
     }
  }
  // select the map image type
  if ( isset($MS['type']) && $MS['type'] == 'jpg' ) {
        $type = 'jpg';
  } else if( isset($MS['type']) && $MS['type'] == 'png' ) {
        $type = 'png';
  } else {
        $type = 'png';
  }

  $xx_secs_ago = (time() - $seconds_ago);

  // get image data
  list($image_worldmap_width, $image_worldmap_height, $image_worldmap_type) = getimagesize($image_worldmap_path);
  list($image_pin_width, $image_pin_height, $image_pin_type) = getimagesize($image_pin_path);

  // map parameters
  $scale = 360 / $image_worldmap_width;

  $image_worldmap_link = '';
  if ( is_array($MS) ) {
    $image_worldmap =  $C['files_url'] .
    'wo-worldmap.php?'.
    'time='.$G['time'].
    '&amp;units='.$G['units'].
    '&amp;map='.$G['map'].
    '&amp;pin='.$G['pin'].
    '&amp;pins=off'.
    '&amp;text='.$G['text_display'].
    '&amp;textcolor='.$G['text_color'].
    '&amp;textshadow='.$G['text_shadow_color'].
    '&amp;textalign='.$G['text_align'].
    '&amp;ul_lat='.$ul_lat.
    '&amp;ul_lon='.$ul_lon.
    '&amp;lr_lat='.$lr_lat.
    '&amp;lr_lon='.$lr_lon.
    '&amp;offset_x='.$offset_x.
    '&amp;offset_y='.$offset_y.
    '&amp;type='.$type;

    $image_worldmap_link =  $C['files_url'] .
    'wo-worldmap.php?'.
    'time='.$G['time'].
    '&units='.$G['units'].
    '&map='.$G['map'].
    '&pin='.$G['pin'].
    '&pins=on'.
    '&text='.$G['text_display'].
    '&textcolor='.$G['text_color'].
    '&textshadow='.$G['text_shadow_color'].
    '&textalign='.$G['text_align'].
    '&ul_lat='.$ul_lat.
    '&ul_lon='.$ul_lon.
    '&lr_lat='.$lr_lat.
    '&lr_lon='.$lr_lon.
    '&offset_x='.$offset_x.
    '&offset_y='.$offset_y.
    '&type='.$type;

$image_worldmap_array = '$map_settings = array(
// html map settings
// set these settings as needed
\'time\'       => \''.$G['time'].'\',  // digits of time
\'units\'      => \''.$G['units'].'\', // minutes, hours, or days (with or without the "s")
\'map\'        => \''.$G['map'].'\',       // 1,2,3 etc. (you can add more map images in settings)
\'pin\'        => \''.$G['pin'].'\',       // 1,2,3 etc. (you can add more pin images in settings)
\'pins\'       => \'off\',     // off (off is required for html map)
\'text\'       => \''.$G['text_display'].'\',      // on or off
\'textcolor\'  => \''.$G['text_color'].'\',  // any hex color code
\'textshadow\' => \''.$G['text_shadow_color'].'\',  // any hex color code
\'textalign\'  => \''.$G['text_align'].'\',      // ll, ul, lr, ur, c, ct, cb (codes for: lower left, upper left, upper right, center, center top, center bottom)
\'ul_lat\'     => \''.$ul_lat.'\',     // default 0 for worldmap
\'ul_lon\'     => \''.$ul_lon.'\',     // default 0 for worldmap
\'lr_lat\'     => \''.$lr_lat.'\',     // default 360 for worldmap
\'lr_lon\'     => \''.$lr_lon.'\',     // default 180 for worldmap
\'offset_x\'   => \''.$offset_x.'\',   // + or - offset for x axis  - moves pins left, + moves pins right
\'offset_y\'   => \''.$offset_y.'\',   // + or - offset for y axis  - moves pins up,   + moves pins down
\'type\'       => \''.$type.'\',     // jpg or png (map output type)
);
echo get_whos_online_worldmap($map_settings);';
  }

  // show worldmap
$string = '<!--
This link is for your reference, it can be pasted into a browser:
'.$image_worldmap_link.'

'.$image_worldmap_array.'
-->
';

$C['maps_in_tables'] and $string .= '<table class="wo_map" border="0" cellpadding="0" cellspacing="0">
 <tr>
   <td>
';
$string .= '<div style="position:relative; border:none; background-image:url('.$image_worldmap.'); width:'.$image_worldmap_width.'px; height:'.$image_worldmap_height.'px;">';
$string .= "\n".'<!--[if lte IE 8 ]>
<div style="position:relative; margin-top: -11px;">
<![endif]-->';
  $string .= "\n";

  // Connect to mysql database
  $wo_dbh = mysql_connect($C['dbhost'], $C['dbuser'], $C['dbpass']);
  if (!$wo_dbh) die('Could not connect: ' . mysql_error($wo_dbh));
  mysql_select_db($C['dbname'],$wo_dbh) or die(mysql_error($wo_dbh));

  if ($C['show_bots_on_worldmap']) {
       $query = "SELECT nickname, country_name, country_code, city_name, state_name, state_code, latitude, longitude
                 FROM ".TABLE_WHOS_ONLINE."
                 WHERE time_last_click > '" . $xx_secs_ago . "'";
  } else {
       $query = "SELECT nickname, country_name, country_code, city_name, state_name, state_code, latitude, longitude
                 FROM ".TABLE_WHOS_ONLINE."
                 WHERE name = 'Guest'
                 AND time_last_click > '" . $xx_secs_ago . "'";
  }

  $result = mysql_query($query,$wo_dbh) or die("Invalid query: " . mysql_error($wo_dbh).__LINE__.__FILE__);

  // create pin on the map
  $count = 0;
  while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
    if ($row['longitude'] != '0.0000' && $row['latitude'] != '0.0000') {
      if ($ul_lat == 0) { // must be the world map
            $count++;
			$x = floor ( ( $row['longitude'] + 180 ) / $scale );
			$y = floor ( ( 180 - ( $row['latitude'] + 90 ) ) / $scale );
	  } else {      // its a custom map
           // filter out what we do not want
           if ( ($row['latitude'] > $lr_lat && $row['latitude'] < $ul_lat) &&
                ($row['longitude'] < $lr_lon && $row['longitude'] > $ul_lon) ) {
            $count++;
            $x = floor ($image_worldmap_width * ($row['longitude'] - $ul_lon) / ($lr_lon - $ul_lon)+ $offset_x);
            $y = floor ($image_worldmap_height * ($row['latitude'] - $ul_lat) / ($lr_lat - $ul_lat)+ $offset_y);

            // discard pixels that are outside the image because of offsets
            if ( ($x < 0 || $x > $image_worldmap_width ) || ($y < 0 || $y > $image_worldmap_height) ) {
               $count--;
               continue;
            }
          } else {
                  continue;
          }
      }
	  $title = '';
      if ( $C['enable_state_display'] ) {
              if ($row['city_name'] != '') {
                if ($row['country_code'] == 'US') {
                     $title = sanitize_output($row['city_name']);
                     if ($row['state_code'] != '')
                             $title = sanitize_output($row['city_name']) . ', ' . sanitize_output(strtoupper($row['state_code']));
                }
                else {      // all non us countries
                     $title = sanitize_output($row['city_name']) . ', ' . sanitize_output(strtoupper($row['country_code']));
                }
             }
             else {
                  $title = '~ ' . $row['country_name'];
             }
      } else {
             $title = $row['country_name'];
      }

      $string .= '<div style="cursor:pointer;position:absolute; top:'.$y.'px; left:'.$x.'px;">
      <img src="'.$image_pin.'" style="border:0; margin:0; padding:0;" width="'.$image_pin_width.'" height="'.$image_pin_height.'" alt="" title="'.sanitize_output($title).'" />
      </div>';
      $string .= "\n";
    }
  }
  $string .= '<!--[if lte IE 8 ]>
</div>
<![endif]-->';
  $string .= "\n";
  $string .= '</div>
';
$C['maps_in_tables'] and $string .= '</td>
 </tr>
</table>
';
  // Close the database connection
  mysql_close($wo_dbh);

  return $string;
} // end function get_whos_online_worldmap

function findYcoord($myLat, $lr_lat, $mapHeight, $rfactor) {
      //$mapHeight = 396;
      //$rfactor = 290; // map scale
      $radBtm = deg2rad($lr_lat);
      $radPixel = deg2rad($myLat);
      $sinRadBtm = sin($radBtm);
      $sinRadPixel = sin($radPixel);
      $convHtBtm = $rfactor * log((1 + $sinRadPixel)/(1 - $sinRadPixel));
      $convHtPixel = $rfactor * log((1 + $sinRadBtm)/(1 - $sinRadBtm));
      $myTotHt = abs($convHtPixel - $convHtBtm);
      $myYcoord = round($mapHeight - $myTotHt, 3);
      return $myYcoord;
}


/**
* Converts value to nonnegative integer.
* @param mixed $maybeint Data you wish to have convered to an nonnegative integer
* @return int An nonnegative integer
*/
if (!function_exists('absint')) {
  function absint( $maybeint ) {
    return abs( intval( $maybeint ) );
 }
}

function get_request_uri() {
  // used for the $last_page_url
  if (isset($_SERVER['REQUEST_URI'])) {
      $uri = $_SERVER['REQUEST_URI'];
  } else {
    if (isset($_SERVER['argv'])) {
      $uri = $_SERVER['PHP_SELF'] .'?'. $_SERVER['argv'][0];
    } else {
      $uri = $_SERVER['PHP_SELF'] .'?'. $_SERVER['QUERY_STRING'];
    }
  }
  return $uri;
}

function get_ip_address() {
   // determine the visitors ip address
   if (getenv('REMOTE_ADDR')) {
        $ip = getenv('REMOTE_ADDR');
   } else if (isset($_SERVER['REMOTE_ADDR'])) {
        $ip = $_SERVER['REMOTE_ADDR'];
   } else {
        $ip = 'unknown';
   }
   return $ip;
}

function get_http_user_agent() {
   // determine the visitors user agent (browser)
   if (getenv('HTTP_USER_AGENT')) {
        $agent = getenv('HTTP_USER_AGENT');
   } else if (isset($_SERVER['HTTP_USER_AGENT'])) {
        $agent = $_SERVER['HTTP_USER_AGENT'];
   } else {
        $agent = 'unknown';
   }
   return $agent;
}

function get_http_referer() {
   // determine the visitors http referer (url they clicked on to get to your site)
   if (getenv('HTTP_REFERER')) {
        $referer = getenv('HTTP_REFERER');
   } else if (isset($_SERVER['HTTP_REFERER'])) {
        $referer = $_SERVER['HTTP_REFERER'];
   } else {
        // sometimes it is just empty
        $referer = '';
   }
   return $referer;
}

// check for empty variable, empty if null, empty if 0, empty if ''
function not_null($value) {
    if (is_array($value)) {
      if (sizeof($value) > 0) {
        return true;
      } else {
        return false;
      }
    } else {
      if (($value != '') && (strtolower($value) != 'null') && (strlen(trim($value)) > 0)) {
        return true;
      } else {
        return false;
      }
    }
}

// functions for protecting and validating form input vars
function wo_clean_input($string) {
    if (is_string($string)) {
      return trim(wo_sanitize_string(strip_tags(wo_stripslashes($string))));
    } elseif (is_array($string)) {
      reset($string);
      while (list($key, $value) = each($string)) {
        $string[$key] = wo_clean_input($value);
      }
      return $string;
    } else {
      return $string;
    }
}

function wo_sanitize_string($string) {
    $string = preg_replace("/ +/", ' ', trim($string));
    return preg_replace("/[<>]/", '_', $string);
}

function wo_stripslashes($string) {
        if (get_magic_quotes_gpc()) {
                return stripslashes($string);
        } else {
                return $string;
        }
}

function wo_output_string($string) {
    return str_replace('"', '&quot;', $string);
}

function check_for_settings () {
    global $C;

    if ( !isset($C['dbhost']) ) {
     echo '<p>Error: Your whose online settings are not properly included for your whos-online page to function.</p>';
     exit;
   }
}

function db_sanitize_input($input) {
    // Parse array
    if (is_array($input)) {
      foreach ($input as $key => $var)
        $input[$key] = db_sanitize_input($var);

      // Parse string
    }
    else {
      // Check if already escaped
      if (get_magic_quotes_gpc()) {
        // Remove not needed escapes
        $input = stripslashes($input);
      }
      // Use proper escape
      $input = mysql_real_escape_string(trim($input));
    }

    // Return sanitized string
    return $input;
} // end function db_sanitize_input

function sanitize_output($output) {
    // Return sanitized string
    return htmlspecialchars($output);
} // end function sanitize_output

function validate_color_wo($string) {
 // protect form input color fields from hackers and check for valid css color code hex
 // only allow simple 6 char hex codes with or without # like this 336699 or #336699

 if (preg_match("/^#[a-f0-9]{6}$/i", trim($string))) {
    return true;
 }
 if (preg_match("/^[a-f0-9]{6}$/i", trim($string))) {
    return true;
 }
 return false;
} // end function validate_color_wo

function validate_text_align($string) {
 // only allow proper text align codes
  $allowed = array('ll','ul','lr','ur','c','ct','cb');
 if ( in_array($string, $allowed) ) {
    return true;
 }
 return false;
} // end function validate_text_align

function host_to_domain($host) {
    if ($host == 'n/a' || !preg_match("/.*\.[a-zA-Z]{2,3}/", $host))  return $host;
    $isp = array_reverse(explode('.', $host));
    $domain = $isp[1].'.'.$isp[0];
    $slds = array(
'\.com\.au',
'\.net\.au',
'\.org\.au',
'\.on\.net',
'\.ac\.uk',
'\.co\.uk',
'\.gov\.uk',
'\.ltd\.uk',
'\.me\.uk',
'\.mod\.uk',
'\.net\.uk',
'\.nic\.uk',
'\.nhs\.uk',
'\.org\.uk',
'\.plc\.uk',
'\.police\.uk',
'\.sch\.uk',);
   foreach ($slds as $k) {
      if(preg_match("/$k$/i", $host)){
        $domain = $isp[2].'.'.$isp[1].'.'.$isp[0];
        break;
      }
   }
    return (preg_match("/[0-9]{1,3}\.[0-9]{1,3}/", $domain)) ? 'n/a' : $domain;
} // end function host_to_domain

function gethostbyaddr_timeout ($ip,$timeout_secs = 2) {
 if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
    //echo 'This is a server using Windows';
    return gethost_win($ip,$timeout_secs);
 } else {
    //echo 'This is a server not using Windows';
    return gethost_lin($ip,$timeout_secs);
 }
} // end function gethostbyaddr_timeout

function gethost_lin ($ip,$timeout_secs = 2) {
 // linux gethostbyaddr with timeout by mike challis
 $time_start = microtime(true); // set a timer
 @exec('host -W '.escapeshellarg($timeout_secs).' '.escapeshellarg($ip), $output); // plan a
 $time_end = microtime(true);  // check the timer
 if(($time_end - $time_start) > $timeout_secs) return 'n/a'; // bail because it timed out
 if (empty($output)) return gethostbyaddr($ip); // plan b, but without timeout
 //$host = isset($output[0]) ? end ( explode (' ', $output[0])) : $ip; // plan a continues
 // mjc applied fix for PHP 5.4  Strict Standards: Only variables should be passed by reference error
 if ( isset($output[0]) ) {
         $array = explode (' ', $output[0]);
         $host = end( $array );
 } else {
         $host = $ip;
 }
 $host = rtrim($host, "\n");
 $host = rtrim($host, '.');
 return (preg_match("/.*\.[a-zA-Z]{2,3}/", $host)) ? $host : 'n/a';
} // end function gethost_lin

function gethost_win ($ip,$timeout_secs = 2) {
 // win32 gethostbyaddr with timeout by mike challis
 $time_start = microtime(true); // set a timer
 @exec('nslookup -timeout='.escapeshellarg($timeout_secs).' '.escapeshellarg($ip), $output); // plan a
 $time_end = microtime(true);  // check the timer
 if(($time_end - $time_start) > $timeout_secs) return 'n/a'; // bail because it timed out
 if (empty($output)) return gethostbyaddr($ip); // plan b, but without timeout
 foreach($output as $line) { // plan a continues
  if(preg_match("/^Name:\s+(.*)$/", $line,$parts)) {
   $host = trim( (isset($parts[1])) ? $parts[1] : '' );
   return (preg_match("/.*\.[a-zA-Z]{2,3}/", $host)) ? $host : 'n/a';
  }
 }
 return 'n/a';
} // end function gethost_win

// end of file